################################### proll.tcl ###############################
#																			#
# scriptlet for drawing a pianoroll widget with pd-extended					#
# use [hcs/sys_gui] for running procedures	or [proll] external				#
#																			#
# patko2012																	#		
#############################################################################


namespace eval ::patco::proll:: {
}
proc ::patco::proll::xview {w args} {
	foreach wid [list $w.tf.cg $w.bf.cg $w.tf.cb $w.tf.ks] {
	eval [linsert $args 0 $wid xview]}
}
proc ::patco::proll::yview {w args} {
	eval [linsert $args 0 $w.tf.cg yview]
	eval [linsert $args 0 $w.tf.ck yview]
}
proc ::patco::proll::zoomx {w x} {
	foreach {canvas} [list $w.tf.cg.f.proll $w.bf.cg.f.proll $w.tf.cb.f.bars $w.tf.ks.f.sig] {
	$canvas configure -width [expr ([winfo width $canvas].0*$x)-3]
	$canvas scale all 0 0 $x 1}
	::patco::proll::viewConfig $w
}
proc ::patco::proll::zoomy {w y} {
	foreach {canvas} [list $w.tf.cg.f.proll $w.tf.ck.f.keys] {
	$canvas configure -height [expr ([winfo height $w.tf.cg.f.proll].0*$y)]
	$canvas scale all 0 0 1 $y}
	::patco::proll::viewConfig $w
}
proc ::patco::proll::zoomCont {w h} {
	set c [$w.bf.cg.f.proll cget -height]
	set h [expr $h-5]
	$w.bf.cg.f.proll configure -height $h
	set f [expr $h.0/($c.0)]
	$w.bf.cg.f.proll scale all 0 0 1 $f
	::patco::proll::viewConfig $w
}
proc ::patco::proll::yscroll {w d} {
	set delta [expr {-($d / 120)}]
	$w.tf.cg yview scroll $delta units
	$w.tf.ck yview scroll $delta units
}
proc ::patco::proll::viewConfig {w} {
	set bbox [$w.tf.cg.f.proll bbox all]
	wm maxsize $w [expr [lindex $bbox 2] + [winfo width $w.tf.ck.f.keys] + 24] [expr [lindex $bbox 3]  + 100]
	foreach canvas [list $w.tf.cg $w.tf.cb $w.bf.cg $w.tf.ck $w.tf.ks] { 
	$canvas configure -scrollregion $bbox}
}
proc ::patco::proll::draw_new {pdreceive w divs steps bars kh title} {
	global settings
	set settings(title) $title
	set settings(keyheight) $kh
	set settings(keywidth) 30
	set settings(bars) $bars
	set settings(divs) $divs
	set settings(steps) $steps
	set settings(vel) 127
	set settings(pdreceive) $pdreceive		
	# font create bars -family {Lucida Sans} -size 10 -weight bold
	# font create temps -family {Lucida Sans} -size 7
	# font create notes -family {Lucida Sans} -size 7
	set wheight 300
	set kw $settings(keywidth)
	set gheight [expr $kh*128]
	toplevel $w -borderwidth 0 -background #000000
	wm title $w $title
	wm geometry $w 300x$wheight+0+0
	wm minsize $w 100 200
	set pwh [panedwindow $w.pwh -showhandle false -orient vertical]
#panedwindow top
	frame $w.tf
	scrollbar $w.tf.sb -orient vertical -command "::patco::proll::yview $w"
	button $w.tf.plus -text "+" -width 1 -height 1 -command "::patco::proll::zoomy $w 1.2"
	button $w.tf.minus -text "-" -width 1 -height 1 -command "::patco::proll::zoomy $w 0.8"
 #grid
	canvas $w.tf.cg  -yscrollcommand [list $w.tf.sb set] -xscrollcommand [list $w.bf.sb set]
	set fgrid [frame $w.tf.cg.f]
	canvas $fgrid.proll -height $gheight -bg white
	grid $fgrid.proll -sticky news
	$w.tf.cg create window 0 0 -anchor nw -window $fgrid
 #keys
	canvas $w.tf.ck -width $kw -yscrollcommand [list $w.tf.sb set]
	set fkeys [frame $w.tf.ck.f]
	canvas $fkeys.keys -width $kw -height $gheight -bg white 
	grid $fkeys.keys -sticky news
	$w.tf.ck create window 0 0 -anchor nw -window $fkeys
 #bars
	canvas $w.tf.cb -height 15 -xscrollcommand [list $w.bf.sb set]
	set fbars [frame $w.tf.cb.f]
	canvas $fbars.bars -height 15 -bg grey90 
	grid $fbars.bars -sticky news
	$w.tf.cb create window 0 0 -anchor nw -window $fbars
 #key signature
	canvas $w.tf.ks -height 15 -xscrollcommand [list $w.bf.sb set]
	set fsig [frame $w.tf.ks.f]
	canvas $fsig.sig -height 15 -bg black
	grid $fsig.sig -sticky news
	$w.tf.ks create window 0 0 -anchor nw -window $fsig

 #dummy
	canvas $w.tf.d -height 30 -width $kw
	set fkeyset [frame $w.tf.d.f]
	canvas $fkeyset.c -height 30 -width $kw -bg grey90
	grid $fkeyset.c -sticky news
	$w.tf.d create window 0 0 -anchor nw -window $fkeyset
 #settings
	set timeratio {4 4 2 2 1 1 "1/8" 0.5 "1/16" 0.25 "1/32" 0.125 "1/64" 0.0625}
	canvas $w.tf.cs -height 20 -bg black
	set fset [frame $w.tf.cs.f]
	label $fset.ql -text Q
	menubutton $fset.q -text "1/16" -menu $fset.q.m -relief sunken -state disabled
	menu $fset.q.m -tearoff 0
	foreach {q f} $timeratio {$fset.q.m add command -label $q -command "::patco::proll::setQ $w $q $f"}
	set settings(quantize) 0.25
	label $fset.ll -text Lenght
	menubutton $fset.l -text "1/16" -menu $fset.l.m -relief sunken
	menu $fset.l.m -tearoff 0
	foreach {q f} $timeratio {$fset.l.m add command -label $q -command "::patco::proll::noteLenght $w $q $f"}
	set settings(notelenght) 0.25	
	label $fset.vl -text Vel
	entry $fset.v -width 3 -relief sunken -bd 2 -textvariable settings(vel)
	pack $fset.ql $fset.q $fset.ll $fset.l $fset.vl $fset.v -side left
	$w.tf.cs create window 0 0 -anchor nw -window $fset
 #top window management
	foreach widget [list $w.tf.cs $w.tf.d $w.tf.ks $w.tf.cb $w.tf.ck $w.tf.cg $w.tf.sb $w.tf.plus $w.tf.minus] {
		row column rowspan columnspan} {0 0 1 3 1 0 2 1 1 1 1 1 2 1 1 1 3 0 3 1 3 1 3 1 3 2 1 1 1 2 1 1 2 2 1 1} {
		grid $widget -row $row -column $column -sticky news -rowspan $rowspan -columnspan $columnspan}
	foreach {index size weight} [list 0 $kw 0 1 50 1 2 10 0] {
		grid columnconfigure $w.tf $index  -minsize $size -weight $weight}
	foreach {index size weight} {0 10 0 1 10 0 2 10 0 3 50 1} {
		grid rowconfigure $w.tf $index  -minsize $size -weight $weight}
#panedwindow bottom
	frame $w.bf
	canvas $w.bf.cg -height 50 -xscrollcommand [list $w.bf.sb set] -bd 0
	scrollbar $w.bf.sb -orient horizontal -command "::patco::proll::xview $w"
	scrollbar $w.bf.dsb -orient vertical
	button $w.bf.plus -bd 0 -text "+" -width 1 -height 1 -command "::patco::proll::zoomx $w 1.2"
	button $w.bf.minus -bd 0 -text "-" -width 1 -height 1 -command "::patco::proll::zoomx $w 0.8"
 #controller
	set fcont [frame $w.bf.cg.f]	
	canvas $fcont.proll -bg white -height 50
	pack $fcont.proll -anchor nw -fill both
	$w.bf.cg create window 0 0 -anchor nw -window $fcont
	canvas $w.bf.ck -height 50 -width $kw
 #dummy
	set fkset [frame $w.bf.ck.f]	
	canvas $fkset.keys -width [expr $kw - 2] -height 70 -bg white	
	$fkset.keys create text 10 10 -fill black -text "Info" -font info
	$fkset.keys create text 10 30 -fill black -tags "note" -text "" -font info
	$fkset.keys create text 15 50 -fill black -tags "vel" -text "" -font info
	grid $fkset.keys -sticky news
	grid columnconfigure $fcont 0 -minsize 30 -weight 1
	grid rowconfigure $fcont 0 -minsize 30 -weight 1
	$w.bf.ck create window 0 0 -anchor nw -window $fkset
 #bottom window management
	foreach widget [list $w.bf.ck $w.bf.cg $w.bf.sb $w.bf.plus $w.bf.minus $w.bf.dsb] {
		row column rowspan colspan} {0 0 2 1 0 1 1 3 1 2 1 1 1 3 1 1 1 1 1 1 0 4 1 1} {
		grid $widget -row $row -column $column -sticky news -rowspan $rowspan -columnspan $colspan}
	grid rowconfigure $w.bf 0 -minsize 50 -weight 1
	grid rowconfigure $w.bf 1 -minsize 10 -weight 0
	
	foreach {index size weight} {0 30 0 1 20 0 2 10 1 3 10 0} {
	grid columnconfigure $w.bf $index -minsize $size -weight $weight}
#panedwindows
    $pwh add $w.tf -sticky news -height [expr $wheight-70]
    $pwh add $w.bf -minsize 70 
	grid $pwh -sticky news
	foreach opt {rowconfigure columnconfigure} {grid $opt $w 0 -minsize 50 -weight 1}
	if {[info tclversion] == 8.5} {
	$pwh paneconfigure $w.tf -stretch always
	$pwh paneconfigure $w.bf -stretch never}
#routin'
	::patco::proll::notes $w
	::patco::proll::timelines $w $gheight

	$fgrid.proll bind hlines <1> "::patco::proll::make_note $fgrid.proll $fcont.proll %x %y settings(vel)"
	$fgrid.proll bind timelines <1> "::patco::proll::make_note $fgrid.proll $fcont.proll %x %y settings(vel)"	
#bindings
	bind $fcont.proll <B1-Motion> "::patco::proll::move_controller $w %x %y"
	bind $fcont.proll <1> "::patco::proll::move_controller $w %x %y"
	bind $w <MouseWheel> "::patco::proll::yscroll $w %D"
 #resize canvas in window
	bind $w.bf.cg <Configure> "::patco::proll::zoomCont $w %h"	
	bind $w  <Destroy> "pdsend \"$title destroy\""	
#cursor
	$fgrid.proll create line 0 0 0 $gheight -tag cursor -fill blue
}
proc ::patco::proll::cursor {w bar beat step} {
	global settings
	set g $w.tf.cg.f.proll
	set bar [expr (($bar-1) % $settings(bars)) + 1]
	set x [lindex [$w.bf.cg.f.proll coords [$w.bf.cg.f.proll find withtag ${bar}.${beat}.${step}]] 0]
	set y [$g cget -height]
	set cursor [$g find withtag cursor]
	$g coords $cursor $x 0 $x $y
}
proc ::patco::proll::notes {w} {
	global settings
	set st $settings(steps)
	set div $settings(divs)
	set kh $settings(keyheight)
	set kw $settings(keywidth)
	set keys $w.tf.ck.f.keys
	set grid $w.tf.cg.f.proll
	set ww [expr $kh*$st*$div*$settings(bars) + 10]
	set notes 128
	set b {0 1 0 0 1 0 1 0 0 1 0 1}
	array set kcs {0 white 1 black 2 yellow 3 {dark orange}}
	$keys delete all
	$grid delete all
	for {set x 0} {$x<$notes} {incr x} {
		set mod [expr $x%12]
		set c [lindex $b $mod]
		set oh [expr $kh*$x]
		set text ""
		if {$c==1} {set col grey90
			set alt sharp} else {set col white
			set alt natural}
		$grid create rectangle 0 $oh $ww [expr $kh+$oh] -fill $col -tag [list hlines $alt $x]
		if {$mod==7} { set oct [expr 8-(($x-7)/12)]
			set text C$oct}
		if {$c==1} {set keylength 20}
		set key [$keys create rectangle 0 $oh $kw [expr $kh+$oh] -fill $kcs($c) -tag [list notes $alt $x  ]]
		$keys create text 2 [expr $oh+($kh/2)] -text $text -anchor w -font notes
		$keys bind $key <1> "pdsend \"$settings(pdreceive) output key $x\""
		$keys bind $key <ButtonRelease-1> "$keys itemconfigure $x -fill $kcs($c)" 
	}

}
proc ::patco::proll::timelines {w hw} {
	global settings
	set kw $settings(keywidth)
	set kh $settings(keyheight)
	set div $settings(divs)
	set st $settings(steps)
	set m $settings(bars)
	set ww [expr $kh*$st*$div*$m + 5]
	set lines [list $w.bf.cg.f.proll $w.tf.cb.f.bars $w.tf.ks.f.sig]
	foreach frame $lines {
		$frame delete all
		$frame configure -width [expr $ww+3]
	}
	$w.tf.cg.f.proll configure -width [expr $ww+3]
	$w.tf.cg.f.proll itemconfigure gridnotes -width $ww 
	set lines [expr $div*$st*$m]
	for {set x 0} {$x <= $lines} {incr x} {
		set ow [expr 5+($ww.0*$x.0)/($div*$st*$m)]
		set c grey60
		set bh 5
		set step [expr ($x%$st)+1]
		set tps [expr (int($x/$st)%$div)+1]
		set mes [expr int($x/($st*$div))+1]
		if {$tps == 1 && $step == 1} {set c grey0
			set bh 50
			::patco::proll::make_line $w $ow $hw $bh $c $mes 1 1 bars
		}
		if {$step == 1 && $tps !=1} {set c grey40
			set bh 10
			::patco::proll::make_line $w $ow $hw $bh $c $mes $tps 1 temps
		}
		if {$step != 1} {
		::patco::proll::make_line $w $ow $hw $bh $c $mes $tps $step step
		}
	}
}
proc ::patco::proll::make_line {w ow hw bh c mesnum temps step font} {	
	if {$step == 1} {
		$w.tf.cb.f.bars create text [expr $ow+1] 7 -anchor nw -text [join [list $mesnum.$temps]] -font $font -tags text
	}
	if {$temps == 1 && $step == 1} {
		$w.tf.ks.f.sig create line $ow 0 $ow $bh -fill white -tag [list timelines 4 4]
		if {$mesnum == 1} {
		$w.tf.ks.f.sig create text [expr $ow+5] 9 -text "4/4" -anchor w -font $font -fill white -tags text
		}
	}
	$w.tf.cg.f.proll create line $ow 0 $ow $hw -fill $c -tag [list timelines $mesnum $temps $step]
	$w.bf.cg.f.proll create line $ow 0 $ow 50 -fill $c -tag [list timelines $mesnum.$temps.$step]
	$w.tf.cb.f.bars create line $ow 0 $ow $bh -fill $c -tag [list timelines]
}
proc ::patco::proll::move_controller {w x y} {
	global settings
	set info [$w.bf.ck.f.keys find withtag vel]
	set controllerCanvas $w.bf.cg.f.proll
	set gridCanvas $w.tf.cg.f.proll
	set height [$controllerCanvas cget -height]
	set x [$controllerCanvas canvasx $x]
	set y [$controllerCanvas canvasy $y]
	set found [$controllerCanvas find overlapping $x $y [expr $x+3] $height]
	foreach tag $found {
		set tags [ $controllerCanvas gettags $tag]
		if {[lindex $tags 0] == "cont"} {
			set note [lindex $tags 1]
			if {[lindex [$gridCanvas gettags $note] 4] != "current"} {
			::patco::proll::sel_note $gridCanvas $controllerCanvas $note $tag
			}			
			set coords [lreplace [eval $controllerCanvas coords $tag] 3 end $y]
			if {$y>4 && $y<=$height} {
				$controllerCanvas coords $tag $coords
				set val [expr int(127.0*(1-(($y-5)/($height-5))))]
				set noteTags [lreplace [$gridCanvas gettags $note] 2 2 $val]
				$gridCanvas itemconfigure $note -tags $noteTags
				pdsend "$settings(pdreceive) output ctl $settings(title) $note $val"
				$w.bf.ck.f.keys itemconfigure $info -text vel:$val 
			}
		}
	}
}
proc ::patco::proll::make_note {w cw x y vel} {
	global settings
	set x [$w canvasx $x]
	set y [$w canvasy $y]
	if {$x>5} {
		set l $settings(notelenght)
		# replace 4 with max step div
		set size [expr int($l*4)]	
		::patco::proll::draw_note $w $cw $x $y $size 1
	}
}
proc ::patco::proll::cmd_note {w cw pos note vel {size 1}} {
	global settings	
	set y [lindex [$w coords [$w find withtag [expr 128 - $note]] ] 1]
	set x [lindex [$cw coords [$cw find withtag $pos] ] 0]
	::patco::proll::draw_note $w $cw $x $y $size 0 $vel

}
proc ::patco::proll::place_note {w x y} {
	set htags [$w find closest $x $y 1 timelines]
	return [list [lindex [$w coords $htags] 1] [lindex [$w coords $htags] 3] $htags]
}
proc ::patco::proll::draw_note {w cw x y s cmd {vel 0}} {
	global settings
	if {$vel <=0} {set vel $settings(vel)}
	set ly [eval [list place_note $w $x $y]]
	set vtags [$w find withtag timelines]
	set x2 [expr $x+[lindex [$w coords [lindex $vtags $s]] 0] - [lindex [$w coords [lindex $vtags 0]] 0]]
	set note [$w create rectangle $x [lindex $ly 0] $x2 [lindex $ly 1] -fill red]
	set cx [lindex [$w coords $note] 0]
	set height [eval $cw cget -height]
	
	set vheight [expr $height - ($height*$vel / 127) + 5]
	set cont [$cw create line $cx $height $cx $vheight -fill red -tags [list cont $note] -capstyle round -width 5]
	set timeref [::patco::proll::quantize_note $w $cw $note $cont]
	set notetags [list note [list [expr 128 - [$w find closest $x $y 1 timelines]] $s] $vel $timeref [expr $s/4] note$y]
	$w itemconfigure $note -tags $notetags
	sel_note $w $cw $note $cont
	if {$cmd == 1} {
		set mon [expr [lindex $timeref 0] +1]
		set don [expr [lindex $timeref 1] +1]
		set son [expr [lindex $timeref 2] +1]
		pdsend "$settings(pdreceive) output note $mon $don $son [expr 128 - [$w find closest $x $y 1 timelines]] $vel $s $note $settings(title)"
	}
	$w bind $note <3> "::patco::proll::delete_note $w $cw $note $cont"
	foreach {widget item} [list $w $note $cw $cont] {
		$widget bind $item <1> "::patco::proll::sel_note $w $cw $note $cont"
	}
}
proc ::patco::proll::resize_note {w n x} {
	$w itemconfigure note -outline black
	$w itemconfigure $n -outline gray
	$w coords $n [lreplace [$w coords $n] 2 2 $x]
	::patco::proll::quantize_note $w $cw $n 1
}
proc ::patco::proll::sel_note {w cw n c} {
	$w itemconfigure note -fill red
	$w itemconfigure $n -fill orange
	$cw itemconfigure cont -fill red
	$cw itemconfigure $c -fill orange
	bind $w <B1-Motion> "::patco::proll::move_note $w $cw $c $n %x %y"
}
proc ::patco::proll::bind_note {w cw c n x y} {
}
proc ::patco::proll::delete_note {w cw n c} {
	$w delete $n
	$cw delete $c
}
proc ::patco::proll::move_note {w cw c n x y} {
	global settings
	set x [$w canvasx $x]
	set y [$w canvasy $y]
	set x1 [lindex [$w coords $n] 0]
	set x2 [lindex [$w coords $n] 2]
	set y1 [lindex [$w coords $n] 1]
	set ly [eval [list place_note $w $x $y]]
	set y [lindex $ly 0]
	$w move $n [expr $x-$x1] [expr $y-$y1]
	$cw move $c [expr $x-$x1] 0
	set timeref [::patco::proll::quantize_note $w $cw $n $c]
	set notetags [lreplace [$w gettags $n] 3 3 $timeref]
	set h [expr 127 - [lindex [$w gettags [$w find closest 1 $y]] 2]]

	$w itemconfigure $n -tags $notetags
	pdsend "$settings(pdreceive) output move $settings(title) $n $timeref $h"	
}
proc ::patco::proll::quantize_note {w cw n c} {
	set x [lindex [$w coords $n] 0]
	set vtags [$w find withtag timelines]
	foreach l $vtags {
		set line [lindex [$w coords $l] 0]
		if { $line <= $x} {
			set x1 [expr $line-$x]
			set list $l
		}
	}
	set tags [$w gettags $list]
	set bars [expr [lindex $tags 1] - 1]
	set beats [expr [lindex $tags 2] - 1]
	set steps [expr [lindex $tags 3] - 1]
	$w move $n $x1 0
	$cw move $c $x1 0
	return [list $bars $beats $steps]
}
proc ::patco::proll::setQ {w q f} {
	::patco::proll::addSetting quantize $f
	$w.tf.cs.f.q configure -text $q
}
proc ::patco::proll::noteLenght {w q f} {
	::patco::proll::addSetting notelenght $f
	$w.tf.cs.f.l configure -text $q
}
proc ::patco::proll::addSetting {key value} {
    global settings
    set settings($key) $value  
 }                               
# in Pd 0.43, the internal proc changed from 'pd' to 'pdsend'
proc ::patco::proll::setup {} {
    # check if we are Pd < 0.43, which has no 'pdsend', but a 'pd' coded in C
    if {[llength [info procs "::pdsend"]] == 0} {
        pdtk_post "creating 0.43+ 'pdsend' using legacy 'pd' proc"
        proc ::pdsend {args} {pd "[join $args { }] ;"}
    }
	
	#catch [console show]	
	font create bars -family {Lucida Sans} -size 10 -weight bold
	font create temps -family {Lucida Sans} -size 7
	font create notes -family {Lucida Sans} -size 7

	font create info -family {Lucida Sans} -size 7
}
